import java.awt.*;
import java.awt.image.*;

abstract
class GleisStueck
{
  int index;
  GleisStueck prev, next;

  Turtle start, end;
  int len;
  
  GleisStueck(GleisStueck prev)
  {
    this.prev = prev;
    prev.next = this;
    this.start = prev.end;
    Assert.assert(this.start != null);
    this.index = prev.index+1;
  }

  GleisStueck(Turtle start) { this.start = start; index = 0; }

  abstract int xkoo(int delta);
  abstract int ykoo(int delta);
  abstract int angle(int delta);

  /* can be overridden by subclasses to speed up things */

  Turtle turtle(int d) { return new Turtle(xkoo(d), ykoo(d), angle(d)); }

  abstract void _paint(Graphics g, ImageObserver observer);

  void paint(Graphics g, ImageObserver observer)
  {
    _paint(g, observer);
    if(next != null) next.paint(g, observer);
  }

  int max_x()
  {
    int m = Math.max(start.x, end.x);
    if(next!=null) m = Math.max(m, next.max_x());
    return m;
  }

  int max_y()
  {
    int m = Math.max(start.y, end.y);
    if(next!=null) m = Math.max(m, next.max_y());
    return m;
  }
}
