import java.awt.*;
import java.awt.image.*;

class Lok
{
  int index;		// should only be set by LokManager

  private static final boolean DEBUG = false;

  private static Image[] images;
  private static int[] xoffset, yoffset, width, height, xmid, ymid;
  private int cached_index=-1;
  private Rectangle cached_rectangle=null;

  int _velocity=1, _direction=1;

  boolean _running = false, _selected = false, _pressed = false,
          remove = false;

  ZugController controller;

  boolean isRunning() { return _running; }
  Turtle pos;

  private synchronized void install_images()
  {
    images = new Image[8];
    images[0] = Resources.instance().getImage("lokE.gif");
    images[1] = Resources.instance().getImage("lokNE.gif");
    images[2] = Resources.instance().getImage("lokN.gif");
    images[3] = Resources.instance().getImage("lokNW.gif");
    images[4] = Resources.instance().getImage("lokW.gif");
    images[5] = Resources.instance().getImage("lokSW.gif");
    images[6] = Resources.instance().getImage("lokS.gif");
    images[7] = Resources.instance().getImage("lokSE.gif");

    { int[] tmp = { 63, 67, 51, 60, 56, 48, 17, 48 }; xoffset = tmp; }
    { int[] tmp = { 50, 60, 52, 46, 15, 50, 60, 68 }; yoffset = tmp; }

    { int[] tmp = { 117, 116, 66, 108, 117, 116, 66, 108 }; width = tmp; }
    { int[] tmp = { 66, 108, 117, 116, 66, 108, 117, 116 }; height = tmp; }

    { int[] tmp = { 20, 27, 30, 27, 16, 16, 10, 16 }; xmid = tmp; }
    { int[] tmp = { 30, 27, 20, 7, 10, 11, 20, 31 }; ymid = tmp; }
  }

  Lok(Turtle pos)
  {
    this.pos = pos;
    if(images==null) install_images();
  }

  void move(Turtle pos)
  {
    this.pos = pos;
    cached_index=-1;
    cached_rectangle=null;
  }

  Turtle pos() { return pos; }

  // void stop() { running = false; }
  // void go() { running = true; }
  // int velocity() { if(running) return velocity; else return 0; }

  private int index()
  {
    if(cached_index>=0) return cached_index;
    int i = pos.alpha % 360;
    if(i<0) i+=360;
    i=(int) Math.round(((double)i) / (360.0/(double)images.length));
    if(i>=images.length) i -= images.length;
    return cached_index=i;
  }

  void paint(Graphics g, ImageObserver observer)
  {
    int i = index();
    g.drawImage(
      images[i], pos.x - xoffset[i], pos.y - yoffset[i], observer);

    if(DEBUG)
      {
        g.setColor(Color.green);
	g.fillRect(pos.x-2, pos.y-2, 4, 4);
      }
  }

  void drawSelection(Graphics g)
  {
    int i = index();
    if(_running) g.setColor(Color.green); else g.setColor(Color.red);
    if(_pressed && !controller.selectionInhibited())
      {
        g.fillOval(pos.x - xmid[i], pos.y - ymid[i], 40, 40);
      }
    else
    if(_selected)
      {
	int x = pos.x - xmid[i], y = pos.y - ymid[i];
        if(controller.selectionInhibited())
	  {
	    g.drawLine(x, y, x + 40, y + 40);
	    g.drawLine(x + 40, y, x, y + 40);
	  }
	else g.drawOval(x, y , 40, 40);
      }
  }

  Rectangle boundingBox()
  {
    if(cached_rectangle!=null) return cached_rectangle;
    int i = index();
    return cached_rectangle = new Rectangle(
      pos.x - xoffset[i], pos.y - yoffset[i], width[i], height[i]);
  }
}
