import java.awt.Rectangle;

class LokManager
{
  private static final boolean DEBUG = false;

  Lok[] lok=null;
  
  synchronized Lok newLok(Turtle t)
  {
    Lok l = new Lok(t);
    int index;
    if(lok==null) index = 0; else index = lok.length;
    l.index = index;
    Lok[] new_lok = new Lok[index+1];
    for(int i=0; i<index; i++)
      new_lok[i]=lok[i];
    lok = new_lok;
    return new_lok[index]=l;
  }

  synchronized void removeLok(Lok l)
  {
    if(lok.length>1)
      {
        Lok[] new_lok=new Lok[lok.length - 1];
	for(int i=0; i<l.index; i++)
	  new_lok[i]=lok[i];
	for(int i=l.index+1; i<lok.length; i++)
	  new_lok[i-1]=lok[i];
	lok=new_lok;
	for(int i=0; i<lok.length; i++)
	  lok[i].index=i;
      }
    else lok=null;
  }

  synchronized Lok lastLok() { return lok[lok.length - 1]; }

  synchronized Turtle collision()
  {
    if(lok!=null)
      {
        for(int i=0; i<lok.length-1; i++)
          for(int j=i+1; j<lok.length; j++)
	    {
		Rectangle r1 = lok[i].boundingBox();
		Rectangle r2 = lok[j].boundingBox();
	        if(r1.intersects(r2))
		  {
		    int x = (r1.x+r2.x+r1.width/2+r2.width/2)/2,
		        y = (r1.y+r2.y+r1.height/2+r2.height/2)/2;

		    if(DEBUG) System.out.println(
		      "Collision(" + x + "," + y + ")");
		    return new Turtle(x,y,0);
		  }
	    }
      }
    
    return null;
  }

  synchronized void setRemoveFlags()
  {
    if(lok != null)
      {
        for(int i=0; i<lok.length; i++)
          lok[i].remove = true;
      }
  }

  void removeAllLoks()
  {
    setRemoveFlags();
    while(lok != null)
      try { Thread.sleep(100); } catch(InterruptedException e) { }
  }
}
