import java.awt.*;
import java.applet.*;

class Resources
{
  private static final boolean DEBUG = false;

  boolean german = false, large = false;
  int version = 0;

  String quit_str, newtrain_str, faster_str, slower_str, stop_str,
         go_str, reset_str, info_str, info_data[];

  String backexplenation;
  char quit_char, newtrain_char, faster_char, slower_char, stop_char,
       go_char, reset_char;

  private ImageName[] images = {
    new ImageName("geradeH.gif"),
    new ImageName("geradeV.gif"),
    new ImageName("gray.gif"),
    new ImageName("green.gif"),
    new ImageName("kurveNE.gif"),
    new ImageName("kurveNW.gif"),
    new ImageName("kurveSE.gif"),
    new ImageName("kurveSW.gif"),
    new ImageName("lokE.gif"),
    new ImageName("lokNE.gif"),
    new ImageName("lokN.gif"),
    new ImageName("lokNW.gif"),
    new ImageName("lokW.gif"),
    new ImageName("lokSW.gif"),
    new ImageName("lokS.gif"),
    new ImageName("lokSE.gif"),
    new ImageName("bang.gif")
  };

  private Resources()
  {
    if(DEBUG) System.out.println("Resources.instance created.");
  } 

  void installLanguage()
  {
    if(german)
      {
	info_str = "Info";
        quit_str = "(E)nde";
	newtrain_str = "(N)euer Zug";
	faster_str = "(S)chneller";
	slower_str = "L(a)ngsamer";
	stop_str = "(H)alt";
	go_str = "(W)eiter";
	reset_str = "(R)eset";

        quit_char = 'e';
	newtrain_char = 'n';
	faster_char = 's';
	slower_char = 'a';
	stop_char = 'h';
	go_char = 'w';
	reset_char = 'r';

	backexplenation =
	  "Zum Rueckwaertsfahren die grosse `Lehrtaste' druecken!";
	

	String[] tmp = {
	  "Ziel dieser Simulation ist es, aufzuzeigen",
	  "wie schwer es ist, Fehler in einem Protokoll",
	  "zu finden.",
	  "",
	  "Dazu kann der Benutzer Zuege eine Strecke",
	  "entlang fahren lassen. Man kann sie steuern",
	  "durch `Klicken' auf den Zug. Klickt man auf",
	  "den Hintergrund, so wird die gesamte",
	  "Simulation gestoppt bzw. wieder fortgesetzt.",
	  "",
	  "In der Version 1.0 ist es ziemlich einfach,",
	  "einen Unfall zu erzeugen. Dazu gibt es nach",
	  "Wissen des Authors vier verschiedene Wege.",
	  "In der Version 1.1 ist nur noch ein sehr",
	  "vertrakter Fehler vorhanden und die",
	  "Version 1.2 sollte von Fehler frei sein."
	};
	info_data = tmp;
	Info.german = true;
      }
    else
      {
	info_str = "info";
        quit_str = "(q)uit";
	newtrain_str = "(n)ew Train";
	faster_str = "(f)aster";
	slower_str = "(s)lower";
	stop_str = "(h)alt";
	go_str = "(g)o";
	reset_str = "(r)eset";

        quit_char = 'q';
	newtrain_char = 'n';
	faster_char = 'f';
	slower_char = 's';
	stop_char = 'h';
	go_char = 'g';
	reset_char = 'r';

	backexplenation =
	  "press `space key' to change the direction of a train!";

	String[] tmp = {
	  "The goal of this simulation is to show",
	  "how hard it could be to find an error",
	  "in a protocol.",
	  "",
          "For this purpose the user can control",
	  "trains by clicking on them. Clicking",
	  "on the background stops (resp. restarts)",
	  "the simulation.",
	  "",
	  "In version 1.0 it is very easy to provoke",
	  "a collision of trains. There seems to be",
	  "at least four ways. In version 1.1 there",
	  "should remain only one way to crash two",
	  "trains and the last version should be",
	  "errorfree."
	};
	info_data = tmp;
	Info.german = false;
      }
  }

  static private Resources instance;
  static Resources instance()
  {
    if(instance == null) instance = new Resources();
    return instance;
  }

  private Applet applet = null;
  private Frame frame = null;

  void useApplet(Applet a)
  {
     if(DEBUG) System.out.println("Resources from an Applet.");
     applet = a;
  }

  void useFrame(Frame f)
  {
    if(DEBUG) System.out.println("Resources from a Frame.");
    frame = f;
  }

  boolean startedAsApplet() { return applet != null; }

  void die() { if(applet==null) System.exit(0); }

  private Image _getImage(String base_name)
  {
    String s = "pics/" + base_name;

    if(DEBUG) System.out.println("low level `getImage(" + s + ")'.");

    if(applet != null) return applet.getImage(applet.getDocumentBase(), s);
    else return frame.getToolkit().getImage(s);
  }

  void loadImages()
  {
    Assert.assert(
      applet != null || frame != null, "Resources not initialized");

    if(DEBUG) System.out.println("Resources.loadImages() ...");

    MediaTracker tracker;
    if(applet==null) tracker = new MediaTracker(frame);
    else tracker = new MediaTracker(applet);

    for(int i=0; i<images.length; i++)
      {
        images[i].image = _getImage(images[i].name);      
	tracker.addImage(images[i].image, 0);
      }
    
    do {
      try { tracker.waitForID(0); } catch(InterruptedException e) { }
    } while(tracker.statusID(0,false) != MediaTracker.COMPLETE);

    if(DEBUG) System.out.println("done.");
  }

  Image getImage(String s)
  {
    for(int i=0; i<images.length; i++)
      if(s.compareTo(images[i].name)==0) return images[i].image;
    
    Assert.assert(false, "image not registered in Resources");
    return null;
  }
}
