class StopAtRedSignalController
  extends ZugController
{
  boolean once = true;
  Signal signal;
  GleisIterator it;

  StopAtRedSignalController(Lok lok, Signal signal, GleisIterator it)
  {
    super(lok);
    if(DEBUG) System.out.println("START StopAtRedSignalController(zug" +
      lok.index + ",signal" + signal.idx + ")");
    this.signal = signal;
    this.it = it;
    lok._running = false;
    lok._direction = 1;		// defensive
    lok._velocity = 1;
  }

  void go()
  {
    if(DEBUG) System.out.println("STOP  StopAtRedSignalController(zug" +
      lok.index + ",signal" + signal.idx + ")");

    if(signal.status == Signal.FREE) 
      lok.controller = new PassGreenSignalController(lok, signal, it);
    else lok.controller = new PassRedSignalController(lok, signal, it);
  }

  void select() { lok._selected = true; }
  void deselect() { lok._selected = false; }
  public void press() { lok._pressed = true; }
  public void release() { lok._pressed = false; }

  boolean selectionInhibited()
  {
    if(once) { once = false; return true; }
    else return false;
  }
}
