import java.awt.*;

public class Zug extends Frame
{
  Panel panel;

  Zug()
  {
    super("Unischau'97 ILKD");
    setLayout(new BorderLayout(0,0));
    Resources.instance().useFrame(this);
    panel = new ZugPanel();
    add("Center", panel);
  }

  static private void usage()
  {
    System.out.print(
      "java Zug [german][english][0-2][small][large][help]\n" +
      "\n" +
      "where\n" +
      "\n" +
      "  english         use English labels (default)\n" +
      "  german          use German labels\n" +
      "  0-3             specify version (default 1)\n" +
      "  small           small window (default)\n" +
      "  large           large window\n" +
      "  help            print this command line summary\n"
      );
  }

  public boolean handleEvent(Event e)
  {
    switch(e.id)
      {
        case Event.WINDOW_DESTROY:
          Resources.instance().die();
	  return true;

        default:
          return super.handleEvent(e);
      }
  }

  public static void main(String[] argv)
  {
    for(int i=0; i<argv.length; i++)
      {
        if(argv[i].equalsIgnoreCase("german"))
	  Resources.instance().german = true;
	else
        if(argv[i].equalsIgnoreCase("english"))
	  Resources.instance().german = false;
	else
	if(argv[i].equalsIgnoreCase("0"))
	  Resources.instance().version = 0;
	else
	if(argv[i].equalsIgnoreCase("1"))
	  Resources.instance().version = 1;
	else
	if(argv[i].equalsIgnoreCase("2"))
	  Resources.instance().version = 2;
	else
	if(argv[i].equalsIgnoreCase("large"))
	  Resources.instance().large = true;
	else
	if(argv[i].equalsIgnoreCase("small"))
	  Resources.instance().large = false;
	else
	if(argv[i].equalsIgnoreCase("help"))
	  {
	    usage();
	    System.exit(0);
	  }
	else
	  {
	    System.err.println(
	      "unknown command line option `" + argv[i] + "'");
	    System.exit(1);
	  }
      }
    
    Resources.instance().installLanguage();

    Zug f = new Zug();
    f.pack();
    f.show();
  }
}
